package com.framework.mvvm.model.db.converter

import androidx.room.TypeConverter
import kotlinx.serialization.decodeFromString
import kotlinx.serialization.json.Json
import kotlinx.serialization.json.JsonObject

/**
 * JsonObject 与 String 转换器
 */
class JsonConverter {
    @TypeConverter
    fun jsonToString(json: JsonObject?): String? {
        return json?.toString()
    }

    @TypeConverter
    fun stringToJson(string: String?): JsonObject? {
        if (string == null) return null
        return Json.decodeFromString<JsonObject>(string)
    }
}