package com.framework.mvvm.model.repository

import androidx.lifecycle.LiveData
import com.framework.app.api.Api
import com.framework.app.base.IRepository
import com.framework.mvvm.model.data.Data
import com.framework.mvvm.model.data.dataSource
import com.framework.mvvm.model.data.request
import com.framework.mvvm.model.db.AdmDatabase
import com.framework.mvvm.model.db.entity.ProjectEntity
import com.framework.mvvm.model.vo.FrameRequest

class FrameRepository(
    private val api: Api,
    private val db: AdmDatabase
) : IRepository {

    fun getProjects(): LiveData<Data<List<ProjectEntity>>> {
        return dataSource(
            fromDb = { db.projectDao().getProjects() },
            fromNt = { request { api.getFrame() } },
            onSuccess = {
                // TODO 拆分 api.getFrame()  返回的结果
            }
        )
    }

    fun getProjects(request: FrameRequest): LiveData<Data<List<ProjectEntity>>> {
        return dataSource(
            fromDb = { db.projectDao().getProjects() },
            fromNt = { request { api.getFrame(request) } },
            onSuccess = { frame ->
                println("frame: $frame")
            }
        )
    }

}